use crate::memory::{MemoryBus, MemoryObserver};
use crate::Clock;
use std::cell::RefCell;
use std::rc::Rc;
use simplelog::info;

pub struct Ppu {
    memory_bus: Rc<RefCell<MemoryBus>>,
}

impl Ppu {
    pub fn new(memory_bus: Rc<RefCell<MemoryBus>>) -> Self {
        Self { memory_bus: memory_bus.clone() }
    }
    
    fn set_register(&self, addr: u16, value: u8) {
        
    }
}

impl MemoryObserver for Ppu {
    fn notify_mem_byte_updated(&mut self, addr: u16, value: u8) {
        info!("MemChange: {:#04x} -> {:#02x}", addr, value);
    }
}

impl Clock for Ppu {
    fn cycle(&mut self) {
        // todo!()
    }
}
